﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace netvis
{
   abstract class Node
    {
        protected SortedList<DateTime,Node> children = new SortedList<DateTime,Node>();
        public SortedList<DateTime, Node> subtress {
            get { return children; }
        }
        protected int numberPass =0;
        public int numberAllow{
            get { return numberPass; }
            set {  }

        }
        protected int numberFail =0;
        public int numberBlock {
            get { return numberFail; }
        }
        public int total {
            get { return numberFail+numberPass;}
        }
        protected DateTime start;
        public DateTime startTime {
            get { return start; }
        }
        public DateTime endTime {
            get { return end; }
        }
        protected DateTime end;
        public abstract void add(Packet child);
        public override string ToString()
        {
            return start.ToString() + " : " + numberPass + numberFail + this.GetType();
        }
        public virtual DateTime findEarliest() {
            if (children.Count>0)
            {
                return children.Values[0].findEarliest();
            }
            return DateTime.MaxValue;
        }
        public virtual DateTime findLatest()
        {
            if (children.Count>0)
            {
                return children.Values[children.Count-1].findLatest();
            }
            return DateTime.MinValue;
        }
        public virtual List<Packet> getAllPackets() {
            List<Packet> list = new List<Packet>();
            foreach (Node node in children.Values)
            {
                list.AddRange(node.getAllPackets());
            }
            return list;
        }
    }
}
