﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace netvis
{
    public class Packet : IComparable
    {
        public enum Direction : int {
        FromIn = 1,
        FromOut = 2
        
        }

        public DateTime time {
            get { return packetTime; }
        }
        protected DateTime packetTime;
        protected String protocol;
        protected int size;
        protected String destIP;
        protected String srcIP;
        protected int srcPort;
        protected int destPort;
        protected String UDPTCP;
        protected bool allowed;
        protected Direction direction;
        public bool pass {
            get { return allowed; }
        }

        public Packet(DateTime time, String protocol, int size, string destIP, string srcIP, int destPort, int srcPort, string UDPTCP, bool pass, Direction direction)
        {
            this.packetTime = time;
            this.protocol = protocol;
            this.size = size;
            this.destIP = destIP;
            this.srcIP = srcIP;
            this.destPort = destPort;
            this.srcPort = srcPort;
            this.UDPTCP = UDPTCP;
            this.allowed = pass;
            this.direction = direction;
        }
        public Packet() { }
        public override int GetHashCode()
        {

            return this.time.GetHashCode()+this.srcPort+this.size+this.destPort;
        }
        public override bool Equals(object obj)
        {
            if (obj.GetType() == this.GetType())
            {
                Packet p = (Packet)obj;
                return (this.destIP==p.destIP&&this.destPort==p.destPort&&this.pass==p.pass&&this.protocol==p.protocol&&this.size==p.size&&this.srcIP==p.srcIP&&this.srcPort==p.srcPort&&this.UDPTCP==p.UDPTCP?true:false);
            }
            else
            {
                return base.Equals(obj);
            }
        }
        public override string ToString()
        {
            return "From "+ this.destIP + " To " + this.srcIP+" At "+this.time.ToString();
        }
        public int CompareTo(object obj) {
            if (obj.GetType() == this.GetType())
            {
                return this.time.CompareTo( ((Packet)obj).time);
            }
            else
            {
                return 0;
            }
        }
        public DateTime getStartTime()
        {
            return time;
        }
        public int getWeight()
        {
            return 1;
        }
        public bool getPass(){
            return pass;
        }

    }
}
